;Cahier des charges :
;1) Un programme 100% GEM qui marche aussi bien en accessoire qu'en programme indpen-
;dant.
;2) Le programme doit permettre, en ouvrant une unique fentre d'avoir un formulaire avec une 
;srie de champs ditables o l'on pourra entrer un texte libre, puis de pouvoir sauver et restaurer 
;ces champs dans un fichier texte via le slecteur de fichiers (extension *.NT). Le texte mis par d-
;faut au chargement (init si accessoire, ou lancement si application) se trouvera dans : "NO-
;TES.NT" qui sera cherch dans le rpertoire de lancement.
;3) Le formulaire contiendra un nombre x de lignes (champs) ditables, cette constante sera 
;nomme FORM_NB_LINES et sera de 4 dans la version de base. Afin de faciliter l'augmentation 
;de ce nombre de champs, les objets seront ordonns (se suivront) au niveau numrotation dans le 
;ressource. Le premier de ces objets se nommera EDTXT_FIRST_EDIT
;4) Quand le texte sera sauv, il le sera en 4 lignes texte termine par RC LF pour pouvoir tre 
;visualis par un autre programme.
;5) Quand le texte sera charg, ce sera via la mmoire puis une recopie du contenu jusqu'au ca-
;ractre RC  occurrence de la taille du champs ditable.
;6) La fentre en question pourra tre namifie, ferme.
;7) Les boutons du formulaire seront : Load  / Save / Close, les racourcis seront respectivement 
;ALT+C / ALT+L / ALT+S, les noms ressources seront BTON_LOAD, BTON_SAVE, 
;BTON_CLOSE. Aucun d'entre eux n'aura la proprit "default".
;8) Le nom TOS de l'application sera "NOTES.ACX"
;9) Il sera enregistr dans la barre des accessoires (ou des applications si multi-tche) sous le 
;nom "Notes 1.0"
;10) Son nom systme sera "VA_NOTES".(pour dtection de prsence par d'autres applica-
;tions)

	output d:\assemble\visual41\samples\tutorial\notes\notes.acx

OPT_FULL_PATHNAMES

	lea objet_application,a1

	include notes.def
	include visual41.s
	include notes.hs
	include notes.obj

	comment HEAD=7
	section TEXT

;---------------------------------------------------------------------------
	; Exemple de programme Visual Assembleur 4.1
	; Proprit : marche aussi bien en accessoire qu'en programme

	; ce programme est un exemple didactique pour l'apprentissage du
	; Visual Assembleur 4.1

;---------------------------------------------------------------------------

FORM_NB_LINES = 4

my_inits:
	lea nom_par_defaut,a0
	lea nom_fichier_nt,a1
	copy_string_0 a0,a1

	bsr charge_fichier_dans_formulaire

	tst GWVA_APP_OBJ_IS_ACC_PRG	; mode de lancement : 0=acc 1=app
	beq.s ne_pas_ouvrir_fenetre_en_init_accessoire

acc_open:	lea objet_fenetre_info,a0
	bra GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND

ne_pas_ouvrir_fenetre_en_init_accessoire:
	rts

bouton_load_clique:
	lea texte_load,a0		; 35 chars max.
	lea mask_nt,a1		; 18 caracteres max
	lea nom_fichier_nt,a2
	bsr FILE_SELECTOR		; => a2 donne pathname de la slection
	tst d0
	ble .annule

	lea nom_fichier_nt,a3		; sauve le nom du nouveau fichier
	copy_string_0 a2,a3

	bsr charge_fichier_dans_formulaire

.annule:	rts

bouton_save_clique:
	lea texte_save,a0		; 35 chars max.
	lea mask_nt,a1		; 18 caracteres max
	lea nom_fichier_nt,a2
	bsr FILE_SELECTOR		; => a2 donne pathname de la slection
	tst d0
	ble .annule

	lea nom_fichier_nt,a3		; sauve le nom du nouveau fichier
	copy_string_0 a2,a3

	bsr sauve_formulaire_dans_fichier

.annule:	rts

evenement_fenetre_fermee:
bouton_close_clique:
app_term:
acc_close:
	tst GWVA_APP_OBJ_IS_ACC_PRG
	bne VISUAL40_END

	rts

charge_fichier_dans_formulaire:
	lea nom_fichier_nt,a0
	move #RAM_TT_ST,d0
	bsr LOAD_FILE_IN_MEM	; a0 : filename,d0=mxallox-mode	retour a0=ptr,d0=length (d0<=0 erreur)
	tst.l d0
	ble.s erreur_malloc_ou_fichier

	move.l a0,ad_malloc
	move.l a0,a2	; a2 sert de pointeur sur le buffer
	move.l a0,a3	; a3 sert de marqueur de fin de buffer
	add.l d0,a3

	move #EDTXT_FIRST_EDIT,d1
	move #FORM_NB_LINES-1,d7

charge_tous_les_champs:
	save.l d1/d7/a2/a3
	move #FORM_INFORMATION,d0
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	load.l d1/d7/a2/a3

	cmp.l a2,a3
	ble.s fin_de_remplissage_prematuree

*	move.w ([a0,ob_spec],te_txtlen),d4		; longueur du texte

	move.b (a0)+,d2

*	cmp.b #rc,

	addq #1,d1
	dbf d0,charge_tous_les_champs

fin_de_remplissage_prematuree:
	clr.b (a1)

	MFREE adresse_malloc

erreur_malloc_ou_fichier:
	rts

sauve_formulaire_dans_fichier:
	FILE_OPEN write,nom_fichier_nt,d7
	tst d7
	bmi.s erreur_nom_fichier	

	move #EDTXT_FIRST_EDIT,d1
	move #FORM_NB_LINES-1,d0

sauve_tous_les_champs:
	save.w d0/d1/d7
	move #FORM_INFORMATION,d0
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	movem.w (sp),d0/d1/d7		; pour avoir d7
	move.l a1,a0
	bsr GWVA_COUNT_BYTES_0
	FWRITE a0,d0,d7
	lea texte_rc_lf,a0
	bsr GWVA_COUNT_BYTES_0
	FWRITE a0,d0,d7
	load.w d0/d1/d7

	addq #1,d1
	dbf d0,sauve_tous_les_champs	

	FCLOSE d7

erreur_nom_fichier:
	rts

	section DATA

nom_par_defaut:dc.b 'NOTES.NT',0
texte_load:	dc.b 'Name of file to load :',0
texte_save:	dc.b 'Name of file to save :',0
mask_nt:	dc.b '*.NT',0
texte_rc_lf:dc.b rc,lf,0
 even
	section BSS

nom_fichier_nt:	ds.b GWVA_MAX_PATH_LENGTH
adresse_malloc:		ds.l 1
 END
